`timescale 1ns/1ps
module testbench_1();

localparam DELAY = 10;
localparam TOTAL_NUMBER = 20;

reg Clk, Rst_n, En, DataIn;
wire [0:4] DataOut;

reg [0:15]  data [0:19];


// clock
always #DELAY Clk = ! Clk;

// initial 
initial begin
    Clk = 1'b1;
    Rst_n = 1'b0;
    En = 1'b0;
    DataIn = 1'b0;
    $readmemh("./data/Data1.txt", data); //read data 
    # 20
    Rst_n = 1'b1;
    # 10
    En = 1'b1;
end


// main
integer j, file;
initial begin
    file = $fopen("result1.txt", "w+");
    # 20;
    for(j = 0;j < 20;j = j + 1) begin
        SetData(data[j]);
    end
    # 10 
    $fwrite(file, "%dth input data = 16'b%b, output data = 5'd%d\n", j, data[j - 1], DataOut);
    En = 1'b0;
    $fclose(file);
    $display("20 datas are testd over\n");
    $finish;
end 

// Instantiation
NumberOfOne One(
    .Clk(Clk),
    .Rst_n(Rst_n),
    .En(En),
    .DataIn(DataIn),
    .DataOut(DataOut)
);


task SetData;

input [15:0] in;
integer i;

for(i = 15;i >= 0;i = i - 1) begin
    DataIn = in[i];
    # 10
    if(i == 15 && j != 0)
        $fwrite(file, "%dth input data = 16'b%b, output data = 5'd%d\n", j, data[j - 1], DataOut);
    # 10;
end
endtask 

endmodule 